ERRORS = {
    0: 'ERR_NO_ERROR',
    1: 'ERR_CONNECT_FAILED',
    2: 'ERR_SERVER_IS_NOT_VPN',
    3: 'ERR_DISCONNECTED',
    4: 'ERR_PROTOCOL_ERROR',
    5: 'ERR_CLIENT_IS_NOT_VPN',
    6: 'ERR_USER_CANCEL',
    7: 'ERR_AUTHTYPE_NOT_SUPPORTED',
    8: 'ERR_HUB_NOT_FOUND',
    9: 'ERR_AUTH_FAILED',
    10: 'ERR_HUB_STOPPING',
    11: 'ERR_SESSION_REMOVED',
    12: 'ERR_ACCESS_DENIED',
    13: 'ERR_SESSION_TIMEOUT',
    14: 'ERR_INVALID_PROTOCOL',
    15: 'ERR_TOO_MANY_CONNECTION',
    16: 'ERR_HUB_IS_BUSY',
    17: 'ERR_PROXY_CONNECT_FAILED',
    18: 'ERR_PROXY_ERROR',
    19: 'ERR_PROXY_AUTH_FAILED',
    20: 'ERR_TOO_MANY_USER_SESSION',
    21: 'ERR_LICENSE_ERROR',
    22: 'ERR_DEVICE_DRIVER_ERROR',
    23: 'ERR_INTERNAL_ERROR',
    24: 'ERR_SECURE_DEVICE_OPEN_FAILED',
    25: 'ERR_SECURE_PIN_LOGIN_FAILED',
    26: 'ERR_SECURE_NO_CERT',
    27: 'ERR_SECURE_NO_PRIVATE_KEY',
    28: 'ERR_SECURE_CANT_WRITE',
    29: 'ERR_OBJECT_NOT_FOUND',
    30: 'ERR_VLAN_ALREADY_EXISTS',
    31: 'ERR_VLAN_INSTALL_ERROR',
    32: 'ERR_VLAN_INVALID_NAME',
    33: 'ERR_NOT_SUPPORTED',
    34: 'ERR_ACCOUNT_ALREADY_EXISTS',
    35: 'ERR_ACCOUNT_ACTIVE',
    36: 'ERR_ACCOUNT_NOT_FOUND',
    37: 'ERR_ACCOUNT_INACTIVE',
    38: 'ERR_INVALID_PARAMETER',
    39: 'ERR_SECURE_DEVICE_ERROR',
    40: 'ERR_NO_SECURE_DEVICE_SPECIFIED',
    41: 'ERR_VLAN_IS_USED',
    42: 'ERR_VLAN_FOR_ACCOUNT_NOT_FOUND',
    43: 'ERR_VLAN_FOR_ACCOUNT_USED',
    44: 'ERR_VLAN_FOR_ACCOUNT_DISABLED',
    45: 'ERR_INVALID_VALUE',
    46: 'ERR_NOT_FARM_CONTROLLER',
    47: 'ERR_TRYING_TO_CONNECT',
    48: 'ERR_CONNECT_TO_FARM_CONTROLLER',
    49: 'ERR_COULD_NOT_HOST_HUB_ON_FARM',
    50: 'ERR_FARM_MEMBER_HUB_ADMIN',
    51: 'ERR_NULL_PASSWORD_LOCAL_ONLY',
    52: 'ERR_NOT_ENOUGH_RIGHT',
    53: 'ERR_LISTENER_NOT_FOUND',
    54: 'ERR_LISTENER_ALREADY_EXISTS',
    55: 'ERR_NOT_FARM_MEMBER',
    56: 'ERR_CIPHER_NOT_SUPPORTED',
    57: 'ERR_HUB_ALREADY_EXISTS',
    58: 'ERR_TOO_MANY_HUBS',
    59: 'ERR_LINK_ALREADY_EXISTS',
    60: 'ERR_LINK_CANT_CREATE_ON_FARM',
    61: 'ERR_LINK_IS_OFFLINE',
    62: 'ERR_TOO_MANY_ACCESS_LIST',
    63: 'ERR_TOO_MANY_USER',
    64: 'ERR_TOO_MANY_GROUP',
    65: 'ERR_GROUP_NOT_FOUND',
    66: 'ERR_USER_ALREADY_EXISTS',
    67: 'ERR_GROUP_ALREADY_EXISTS',
    68: 'ERR_USER_AUTHTYPE_NOT_PASSWORD',
    69: 'ERR_OLD_PASSWORD_WRONG',
    73: 'ERR_LINK_CANT_DISCONNECT',
    74: 'ERR_ACCOUNT_NOT_PRESENT',
    75: 'ERR_ALREADY_ONLINE',
    76: 'ERR_OFFLINE',
    77: 'ERR_NOT_RSA_1024',
    78: 'ERR_SNAT_CANT_DISCONNECT',
    79: 'ERR_SNAT_NEED_STANDALONE',
    80: 'ERR_SNAT_NOT_RUNNING',
    81: 'ERR_SE_VPN_BLOCK',
    82: 'ERR_BRIDGE_CANT_DISCONNECT',
    83: 'ERR_LOCAL_BRIDGE_STOPPING',
    84: 'ERR_LOCAL_BRIDGE_UNSUPPORTED',
    85: 'ERR_CERT_NOT_TRUSTED',
    86: 'ERR_PRODUCT_CODE_INVALID',
    87: 'ERR_VERSION_INVALID',
    88: 'ERR_CAPTURE_DEVICE_ADD_ERROR',
    89: 'ERR_VPN_CODE_INVALID',
    90: 'ERR_CAPTURE_NOT_FOUND',
    91: 'ERR_LAYER3_CANT_DISCONNECT',
    92: 'ERR_LAYER3_SW_EXISTS',
    93: 'ERR_LAYER3_SW_NOT_FOUND',
    94: 'ERR_INVALID_NAME',
    95: 'ERR_LAYER3_IF_ADD_FAILED',
    96: 'ERR_LAYER3_IF_DEL_FAILED',
    97: 'ERR_LAYER3_IF_EXISTS',
    98: 'ERR_LAYER3_TABLE_ADD_FAILED',
    99: 'ERR_LAYER3_TABLE_DEL_FAILED',
    100: 'ERR_LAYER3_TABLE_EXISTS',
    101: 'ERR_BAD_CLOCK',
    102: 'ERR_LAYER3_CANT_START_SWITCH',
    103: 'ERR_CLIENT_LICENSE_NOT_ENOUGH',
    104: 'ERR_BRIDGE_LICENSE_NOT_ENOUGH',
    105: 'ERR_SERVER_CANT_ACCEPT',
    106: 'ERR_SERVER_CERT_EXPIRES',
    107: 'ERR_MONITOR_MODE_DENIED',
    108: 'ERR_BRIDGE_MODE_DENIED',
    109: 'ERR_IP_ADDRESS_DENIED',
    110: 'ERR_TOO_MANT_ITEMS',
    111: 'ERR_MEMORY_NOT_ENOUGH',
    112: 'ERR_OBJECT_EXISTS',
    113: 'ERR_FATAL',
    114: 'ERR_SERVER_LICENSE_FAILED',
    115: 'ERR_SERVER_INTERNET_FAILED',
    116: 'ERR_CLIENT_LICENSE_FAILED',
    117: 'ERR_BAD_COMMAND_OR_PARAM',
    118: 'ERR_INVALID_LICENSE_KEY',
    119: 'ERR_NO_VPN_SERVER_LICENSE',
    120: 'ERR_NO_VPN_CLUSTER_LICENSE',
    121: 'ERR_NOT_ADMINPACK_SERVER',
    122: 'ERR_NOT_ADMINPACK_SERVER_NET',
    123: 'ERR_BETA_EXPIRES',
    124: 'ERR_BRANDED_C_TO_S',
    125: 'ERR_BRANDED_C_FROM_S',
    126: 'ERR_AUTO_DISCONNECTED',
    127: 'ERR_CLIENT_ID_REQUIRED',
    128: 'ERR_TOO_MANY_USERS_CREATED',
    129: 'ERR_SUBSCRIPTION_IS_OLDER',
    130: 'ERR_ILLEGAL_TRIAL_VERSION',
    131: 'ERR_NAT_T_TWO_OR_MORE',
    132: 'ERR_DUPLICATE_DDNS_KEY',
    133: 'ERR_DDNS_HOSTNAME_EXISTS',
    134: 'ERR_DDNS_HOSTNAME_INVALID_CHAR',
    135: 'ERR_DDNS_HOSTNAME_TOO_LONG',
    136: 'ERR_DDNS_HOSTNAME_IS_EMPTY',
    137: 'ERR_DDNS_HOSTNAME_TOO_SHORT',
    138: 'ERR_MSCHAP2_PASSWORD_NEED_RESET',
    139: 'ERR_DDNS_DISCONNECTED',
    140: 'ERR_SPECIAL_LISTENER_ICMP_ERROR',
    141: 'ERR_SPECIAL_LISTENER_DNS_ERROR',
    142: 'ERR_OPENVPN_IS_NOT_ENABLED',
    143: 'ERR_NOT_SUPPORTED_AUTH_ON_OPENSOURCE',
    144: 'ERR_VPNGATE',
    145: 'ERR_VPNGATE_CLIENT',
    146: 'ERR_VPNGATE_INCLIENT_CANT_STOP',
    147: 'ERR_NOT_SUPPORTED_FUNCTION_ON_OPENSOURCE'
}


def strerror(errno):
    return ERRORS.get(errno, "ERR_UNKNOWN")